/*
Copyright 2002 Lee Soon Gyu

[In Korean]
 α׷ ̹Ƿ   ƴ ѵ
 뵵 ο    մϴ.
, α׷ Ͻ 쿡 ó (̼)
ݵ  ֽñ ٶϴ.

[In English]
This program is free software, so you can freely distribute it
and modify it without any commercial purpose.
When you distribute it, you should have to specify the author
of this program.

Written by Lee Soon Gyu (lsg0222@hanmail.net)
*/

#include "sound.h"

static DSound *dsound = NULL;
static BOOL soundOK = FALSE;


void initSound(HWND hwnd)
{
	dsound = new DSound;

	if(!dsound->init(hwnd)) soundOK = FALSE;
	else soundOK = TRUE;
}


void deleteSound()
{
	if(dsound) delete dsound;
}


BOOL loadSound()
{
	if(!soundOK) return FALSE;
	if(dsound->loadWAV("Default.wav")<0) return FALSE;
	if(dsound->loadWAV("Pacman.wav")<0) return FALSE;
	if(dsound->loadWAV("Menu.wav")<0) return FALSE;
	if(dsound->loadWAV("MenuCommand.wav")<0) return FALSE;
	if(dsound->loadWAV("Transmission.wav")<0) return FALSE;
	if(dsound->loadWAV("EatDot.wav")<0) return FALSE;
	if(dsound->loadWAV("EatPower.wav")<0) return FALSE;
	if(dsound->loadWAV("EatPower2.wav")<0) return FALSE;
	if(dsound->loadWAV("EatGhost.wav")<0) return FALSE;
	if(dsound->loadWAV("Kill.wav")<0) return FALSE;
	if(dsound->loadWAV("Excellent.wav")<0) return FALSE;
	if(dsound->loadWAV("Ouch.wav")<0) return FALSE;
	if(dsound->loadWAV("Ouch2.wav")<0) return FALSE;
	if(dsound->loadWAV("Dying.wav")<0) return FALSE;
	if(dsound->loadWAV("Portal.wav")<0) return FALSE;
	if(dsound->loadWAV("Dingdong.wav")<0) return FALSE;
	if(dsound->loadWAV("Pong.wav")<0) return FALSE;
	if(dsound->loadWAV("BonusLife.wav")<0) return FALSE;
	if(dsound->loadWAV("Count.wav")<0) return FALSE;
	if(dsound->loadWAV("Ding.wav")<0) return FALSE;
	if(dsound->loadWAV("BonusScore.wav")<0) return FALSE;
	if(dsound->loadWAV("HighScore.wav")<0) return FALSE;
	if(dsound->loadWAV("Pikachu.wav")<0) return FALSE;
	if(dsound->loadWAV("Pikapika.wav")<0) return FALSE;
	if(dsound->loadWAV("GameExit.wav")<0) return FALSE;
	if(dsound->loadWAV("BGM.wav")<0) return FALSE;

	return TRUE;
}


void playSound(int id)
{
	if(soundOK && id>0){
		dsound->play(--id);
	}
}


void stopSound(int id)
{
	if(soundOK && id>0){
		dsound->stop(--id);
	}
}


BOOL isPlaying(int id)
{
	if(soundOK && id>0){
		return dsound->isPlaying(--id);
	}
	return FALSE;
}
